#include <errno.h>
#include <stdio.h>
#include "criterr.h"

/* example program to test critical error trap routine */
/* link in module criterr.obj, or add to library */
/* for buffered i/o devices, better flush them otherwise errors */
/* will be delayed until buffer gets written */

/* WRITTEN BY PETER HYMAN, (609) 799-2638 */

main()
{
	int i;
	FILE *fp;

	i = criterr( 1 );                              /* trap critical error */
	fputs( "abcde", stdprn );
	fflush ( stdprn );       		                   /* TAKE PRINTER OFF LINE */
	if ( cerr.cerrno )
        printf( "Critical error: %d - %s, type: %X -- Device Name: %8s\n\
Drive: %c\n\
READ or WRITE: %d\n\
DISK Area of Error: %d\n\
Response Mask: %d\n\
Extended Error Number (Dos >= 3): %d -- %s\n\
Error Class: %d -- %s\n\
Error Recovery Action Recommendation: %d -- %s\n\
Error Locus: %d -- %s\n\n",
cerr.cerrno, crit_errlist[cerr.cerrno], cerr.cerrtype,
cerr.name,cerr.drive, cerr.read_wr, cerr.disk_area, cerr.resp_mask,
cerr.exterr,os_errlist[cerr.exterr],
cerr.eclass,err_classlist[cerr.eclass],
cerr.action, err_actionlist[cerr.action],
cerr.locus, err_locuslist[cerr.locus] );
	clrcriterr();
	if ( ( fp = fopen( "a:junk", "r" ) ) == NULL ) /* OPEN DRIVE A DOOR OR PUT A DISK IN */
	{
		if ( cerr.cerrno )
        printf( "Critical error: %d - %s, type: %X -- Device Name: %8s\n\
Drive: %c\n\
READ or WRITE: %d\n\
DISK Area of Error: %d\n\
Response Mask: %d\n\
Extended Error Number (Dos >= 3): %d -- %s\n\
Error Class: %d -- %s\n\
Error Recovery Action Recommendation: %d -- %s\n\
Error Locus: %d -- %s\n\n",
cerr.cerrno, crit_errlist[cerr.cerrno], cerr.cerrtype,
cerr.name,cerr.drive, cerr.read_wr, cerr.disk_area, cerr.resp_mask,
cerr.exterr,os_errlist[cerr.exterr],
cerr.eclass,err_classlist[cerr.eclass],
cerr.action, err_actionlist[cerr.action],
cerr.locus, err_locuslist[cerr.locus] );
		else if ( errno )                            /* see if file not found error or such */
				printf( "Non Critical Error %d\n", errno );
	}
	clrcriterr();
	printf( "Critical error trap is now turned off.\n");
	i = criterr( 0 );                              /* remove trap */
	fp = fopen( "a:junk", "r" );
}
